
var markerOptions_general = ['general', 'general-small', ];
var markerOptions_commentary_point = ['commentary-point'];
var markerOptions_stop = ['stop'];
var markerOptions_event = ['event', 'animal-encounter', 'keeper-talk'];
var markerOptions_toilet = ['mf-toilet', 'accessible-toilet', 'parents-room', ];
var markerOptions_accomodation = ['youth-hostel'];
var markerOptions_eatery = ['eatery',];
var markerOptions_attraction = ['waterfall', 'ruin', 'tower','peak' ];
var markerOptions_plants = ['plant', ];
var markerOptions_animals = ['animal','cassowary' ];
var markerOptions_building = ['building', 'education-centre', 'sculpture', 'fountain', 'heretage', 'art-and-culture'];
var markerOptions_exit = ['exit',  ];
var markerOptions_rest = ['kids-play-area', 'picnic', ];
var markerOptions_water = ['water', ];
var markerOptions_access = [ 'gate', 'parking', 'escalator', 'lift', 'stairs', 'trail', 'wheelchair-access', 'no-public-access', 'steep-gradient'];
var markerOptions_transportation = ['bus', 'bike','to-cairns'];
var markerOptions_information = ['wifi', 'information', 'tickets', 'lockers', 'smoking', 'public-fire-evacuation-assembly-point'];
var markerOptions_shops = ['atm', 'shop', 'stroller-hire', ];
var markerOptions_first_aid = ['first-aid', ];
var markerOptions_system = ['temp'];


var markerOptions = [];
markerOptions = markerOptions.concat(markerOptions_commentary_point);
markerOptions = markerOptions.concat(markerOptions_general);
markerOptions = markerOptions.concat(markerOptions_stop);
markerOptions = markerOptions.concat(markerOptions_event);
markerOptions = markerOptions.concat(markerOptions_eatery);
markerOptions = markerOptions.concat(markerOptions_accomodation);
markerOptions = markerOptions.concat(markerOptions_toilet);
markerOptions = markerOptions.concat(markerOptions_attraction);
markerOptions = markerOptions.concat(markerOptions_plants);
markerOptions = markerOptions.concat(markerOptions_animals);
markerOptions = markerOptions.concat(markerOptions_building);
markerOptions = markerOptions.concat(markerOptions_exit);
markerOptions = markerOptions.concat(markerOptions_rest);
markerOptions = markerOptions.concat(markerOptions_water);
markerOptions = markerOptions.concat(markerOptions_access);
markerOptions = markerOptions.concat(markerOptions_transportation);
markerOptions = markerOptions.concat(markerOptions_information);
markerOptions = markerOptions.concat(markerOptions_shops);
markerOptions = markerOptions.concat(markerOptions_first_aid);
markerOptions = markerOptions.concat(markerOptions_system);

markerOptions.sort(function(a, b){
	 var nameA=a.toLowerCase(), nameB=b.toLowerCase();
	 if (nameA < nameB) //sort string ascending
	  return -1;
	 if (nameA > nameB)
	  return 1;
	 return 0; //default return value (no sorting)
	});
//console.log(JSON.stringify(markerOptions))

var addToMyDayOptions = {
	'keeper talk': true,
	'animal encounter': true,
}

var defaultMarkerOption = 'general';


var markerStylesTemplates = {
	'default': {
		"normal":{
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.5,
					opacity :1,
					'icon_dir': './assets/marker_icons/normal/',
					'icon_ext': '.png',
				},
		"tour": {
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.5,
					opacity :1,
					'icon_dir': './assets/marker_icons/tour/',
					'icon_ext': '.png',
				},
		"visited": {
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.5,
					opacity :1,
					'icon_dir': './assets/marker_icons/visited/',
					'icon_ext': '.png',
				},
		'preview_file': './assets/marker_icons/preview/generic.jpg',		
		'preview_ext': '.jpg',

	},
	
	'general-small': {
		"normal":{
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.4,
					opacity :1,
					'icon_dir': './assets/marker_icons/normal/',
					'icon_ext': '.png',
				},
		"tour": {
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.4,
					opacity :1,
					'icon_dir': './assets/marker_icons/tour/',
					'icon_ext': '.png',
				},
		"visited": {
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.4,
					opacity :1,
					'icon_dir': './assets/marker_icons/visited/',
					'icon_ext': '.png',
				},
		'preview_file': './assets/marker_icons/preview/generic.jpg',	
		'preview_ext': '.jpg',
	},
		
	'temp': {
		"normal":{
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.4,
					opacity : 0,
					'icon_dir': './assets/marker_icons/normal/',
					'icon_ext': '.png',
				},
		"tour": {
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.4,
					opacity : 0,
					'icon_dir': './assets/marker_icons/normal/',
					'icon_ext': '.png',
				},
		"visited": {
					anchor: [0.5, 0.5],
					anchorXUnits: 'fraction',
					anchorYUnits: 'fraction',
					scale: 0.4,
					opacity : 0,
					'icon_dir': './assets/marker_icons/normal/',
					'icon_ext': '.png',
				},
		'preview_file': './assets/marker_icons/preview/generic.jpg',	
		'preview_ext': '.jpg',
	},
}

var markerStyles={};

function initMarkerStyles()


{
	for (var key in markerOptions) {
		var markerDefDic ={};
		var markerName = markerOptions[key];
		var styleTemplateKey = 'default';
		if(markerStylesTemplates[markerName]){
			styleTemplateKey = markerName;
		} 
		var styleTemplate = markerStylesTemplates[styleTemplateKey];
		
		var markerStyleNormal = {
		"normal": new ol.style.Style({
			image: new ol.style.Icon(/** @type {olx.style.IconOptions} */
				({
					anchor: styleTemplate["normal"].anchor,
					anchorXUnits: styleTemplate["normal"].anchorXUnits,
					anchorYUnits: styleTemplate["normal"].anchorYUnits,
					scale: styleTemplate["normal"].scale,
					opacity: styleTemplate["normal"].opacity,
					src: styleTemplate["normal"]['icon_dir'] + markerName + styleTemplate["normal"]['icon_ext']
				}))
				
		}),
		"tour": new ol.style.Style({
			image: new ol.style.Icon(/** @type {olx.style.IconOptions} */
				({
					anchor: styleTemplate["tour"].anchor,
					anchorXUnits: styleTemplate["tour"].anchorXUnits,
					anchorYUnits: styleTemplate["tour"].anchorYUnits,
					scale: styleTemplate["tour"].scale,
					opacity: styleTemplate["tour"].opacity,
					src: styleTemplate["tour"]['icon_dir'] + markerName + styleTemplate["tour"]['icon_ext']
				}))
		}),
		"visited": new ol.style.Style({
			image: new ol.style.Icon(/** @type {olx.style.IconOptions} */
				({
					anchor: styleTemplate["visited"].anchor,
					anchorXUnits: styleTemplate["visited"].anchorXUnits,
					anchorYUnits: styleTemplate["visited"].anchorYUnits,
					scale: styleTemplate["visited"].scale,
					opacity: styleTemplate["visited"].opacity,
					src: styleTemplate["visited"]['icon_dir'] + markerName + styleTemplate["visited"]['icon_ext']
				}))
		}),
		'default_preview': styleTemplate['preview_file'],
		}
		markerStyleNormal['normal']['defaultScale'] = styleTemplate["normal"].scale;
		//console.log(styleTemplate["normal"]['icon_dir'] + markerName + styleTemplate["normal"]['icon_ext']);
		//console.log(styleTemplate['preview_dir'] + markerName + styleTemplate['preview_ext']);
		var markerStyleTour = {
					"normal": new ol.style.Style({
			image: new ol.style.Icon(/** @type {olx.style.IconOptions} */
				({
					anchor: styleTemplate["normal"].anchor,
					anchorXUnits: styleTemplate["normal"].anchorXUnits,
					anchorYUnits: styleTemplate["normal"].anchorYUnits,
					scale: styleTemplate["normal"].scale,
					opacity: styleTemplate["normal"].opacity,
					src: styleTemplate["normal"]['icon_dir'] + markerName + styleTemplate["normal"]['icon_ext']
				}))
				
		}),
		"tour": new ol.style.Style({
			image: new ol.style.Icon(/** @type {olx.style.IconOptions} */
				({
					anchor: styleTemplate["tour"].anchor,
					anchorXUnits: styleTemplate["tour"].anchorXUnits,
					anchorYUnits: styleTemplate["tour"].anchorYUnits,
					scale: styleTemplate["tour"].scale,
					opacity: styleTemplate["tour"].opacity,
					src: styleTemplate["tour"]['icon_dir'] + markerName + styleTemplate["tour"]['icon_ext']
				}))
		}),
		"visited": new ol.style.Style({
			image: new ol.style.Icon(/** @type {olx.style.IconOptions} */
				({
					anchor: styleTemplate["visited"].anchor,
					anchorXUnits: styleTemplate["visited"].anchorXUnits,
					anchorYUnits: styleTemplate["visited"].anchorYUnits,
					scale: styleTemplate["visited"].scale,
					opacity: styleTemplate["visited"].opacity,
					src: styleTemplate["visited"]['icon_dir'] + markerName + styleTemplate["visited"]['icon_ext']
				}))
		}),
		'default_preview': styleTemplate['preview_file'],
		}
		markerStyleTour['tour']['defaultScale'] = styleTemplate["tour"].scale;
		markerStyleTour['visited']['defaultScale'] = styleTemplate["visited"].scale;
		markerStyles[markerName] = markerStyleNormal;
		markerStyles[markerName+'_tour'] = 	markerStyleTour;
	}
  //  for (var key in markerStyles) {
	//	console.log(key)
//	}
		
		
	
}

initMarkerStyles();

