
function LookAssistant(navigatorCore) {
	this.navigatorCore = navigatorCore;
	this.rotatingSlider = new RotatingSlider();
	this.isActive = false;

	this.scanForItems = function () {
			//	console.log('scan for items');
			if (!navigatorCore.locationManager.getLastKnownLocation()) {
				appConnector.handleError('1',langString (language, 'warning_no_location'));
				return;
			}

			if (!ol.extent.containsCoordinate(viewableBounds, navigatorCore.locationManager.getLastKnownLocation())) {
				appConnector.handleError('2',langString (language, 'warning_outside_bounds'));
			
				return;
			}
		this.rotatingSlider.clearItems();
		var userLocation = this.navigatorCore.locationManager.getLastKnownLocation();
		if (userLocation) {
			this.findItems();
			this.rotatingSlider.prepareItemsList();
			this.rotatingSlider.createScannerDOM();
			this.sliderScanner = $("#content-slider").lightSlider({
					gallery : false,
					pager : false,
					//item : 3,
					loop : true,
					slide : false,
					slideEndAnimation : true,
					slideMargin : 5,
					enableTouch : false,
					enableDrag : false,
					freeMove : false,
					controls : false,
				});
			this.lastRotation = undefined;
			this.setActive(true);
			this.deviceOrientationChanged(this.navigatorCore.orientationManager.getLastKnownRotationDeg());
		}
	}

	this.setActive = function (flag) {
		this.isActive = flag;
	}

	this.findItems = function () {
		var userLocation = this.navigatorCore.locationManager.getLastKnownLocation();
		var items = this.navigatorCore.navItemFLayer.boundItemsData;
		 
		for (var key in items) {
			var itemData = items[key];
		//	console.log('itemData.markerType ' +itemData.marker_type)
			if (itemData['gType'] == 'Point' && !disabledTypes[itemData.marker_type]) {
				//console.log('loadPoint ');
				//itemData['coord']
				//itemData['id'];
				//	itemData['popupHeading'];
				//	itemData['popupText'];

				//var shortestPath = this.navigatorCore.findShortestPath(itemData['id'])
				//var distanceToItem = shortestPath.d * this.navigatorCore.mapMetersPerCoordinatePoint;
				var directDistanceToItem =this.navigatorCore.navPathAssistant.getDistanceMeteres(userLocation, itemData['coord']);
				//console.log('directDistanceToItem ' + directDistanceToItem);
				//console.log('this.navigatorCore.lookRadius  ' + this.navigatorCore.lookRadius );
				if (directDistanceToItem <= this.navigatorCore.lookRadius ) {
				//console.log('directDistanceToItem ' + (directDistanceToItem <= this.navigatorCore.lookRadius) );
					var distanceToItemM = this.navigatorCore.findDistanceToItemM(itemData['id']);

					var angleForItem = this.navigatorCore.navPathAssistant.calculateAngle2Vectors2(userLocation, itemData['coord']);
					//angleForItem.angleRad;
					//angleForItem.angleDeg;
					//angleForItem.angleDegDO;
					//console.log("shortestPath.d+" + shortestPath.d);
					this.rotatingSlider.addItem({
						'type' : 'item',
						'id' : itemData['id'],
						'name' : itemData.popupHeading,
						'angle' : Math.round(angleForItem.angleDegDO),
						'th_url' : itemData.popupPreviewURL,
						'distance' : distanceToItemM,
						'popup_content' : itemData.popup_content
					});
				}
			}

		}
	}

	this.deviceOrientationChanged = function (newRotationDegrees) {

		if (this.isActive) {
			this.updateScannerView(newRotationDegrees);
		}
		this.lastRotation = newRotationDegrees;
	}

	this.userLocationChanged = function (newLocation) {
		if (this.isActive) {
			this.cleanup()
			this.scanForItems()
		}
	}

	this.updateScannerView = function (newRotationDegrees) {

		if (!this.lastRotation || Math.abs(this.lastRotation - newRotationDegrees) > Math.PI / 30) {
			

			//alert("updateScannerView =" +newRotationDegrees);

			//document.getElementById('degrees').innerText = newRotationDegrees;

			var slideIndex = this.sliderScanner.getCurrentSlideCount();
			//alert("updateScannerView =" +this.sliderScanner.getCurrentSlideCount());
		
			//	alert("this.rotatingSlider =" + this.rotatingSlider);
			var nextItem = this.rotatingSlider.getNextItem(Math.round(newRotationDegrees));
			if (nextItem) {
				var newSlideIndex = nextItem['index'];
			//	var itemsNumber = this.rotatingSlider.getItemsNumber();
				//document.getElementById('degrees').innerText = this.sliderScanner.getCurrentSlideCount();

				this.sliderScanner.goToSlide(newSlideIndex);

				} else {
					

				}

			}
		
	}

	this.cleanup = function () {
		if (this.sliderScanner)
			this.sliderScanner.destroy();
		$("#content-slider").empty();

	}
}

function RotatingSlider() {

	this.items = [];
	this.selectableItems = [];
	this.itemsLookup = {};
	this.sector1 = {};
	this.sector2 = {};
	this.sector3 = {};
	this.sector4 = {};

	this.clearItems = function () {
		this.items = [];
		this.selectableItems = [];
		this.itemsLookup = {};
		this.sector1 = {};
		this.sector2 = {};
		this.sector3 = {};
		this.sector4 = {};
	}

	this.initWithDemoData = function () {
		this.addItem({
			'type' : 'item',
			'angle' : 2,
			'url' : 'img/s1.jpg',
			'th_url' : 'img/thumb2/s1.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 20,
			'url' : 'img/s2.jpg',
			'th_url' : 'img/thumb2/s2.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 60,
			'url' : 'img/s3.jpg',
			'th_url' : 'img/thumb2/s3.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 120,
			'url' : 'img/s4.jpg',
			'th_url' : 'img/thumb2/s4.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 142,
			'url' : 'img/s5.jpg',
			'th_url' : 'img/thumb2/s5.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 150,
			'url' : 'img/s6.jpg',
			'th_url' : 'img/thumb2/s6.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 230,
			'url' : 'img/s8.jpg',
			'th_url' : 'img/thumb2/s8.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 320,
			'url' : 'img/s9.jpg',
			'th_url' : 'img/thumb2/s9.jpg'
		});
		this.addItem({
			'type' : 'item',
			'angle' : 350,
			'url' : 'img/s10.jpg',
			'th_url' : 'img/thumb2/s10.jpg'
		});

	};

	this.addItem = function (itemData) {
		var angle = itemData['angle'];
		if (angle < 90) {
			this.sector1[angle] = itemData;
		} else if (angle < 180) {
			this.sector2[angle] = itemData;
		} else if (angle < 270) {
			this.sector3[angle] = itemData;
		} else if (angle <= 360) {
			this.sector4[angle] = itemData;
		}

	};

	this.prepareItemsList = function () {
		this.checkAndUpdateSector(this.sector1, 0);
		this.checkAndUpdateSector(this.sector2, 90);
		this.checkAndUpdateSector(this.sector3, 180);
		this.checkAndUpdateSector(this.sector4, 270);
		this.processSector(this.sector1);
		this.processSector(this.sector2);
		this.processSector(this.sector3);
		this.processSector(this.sector4);
		//console.log("items = " + JSON.stringify(this.items));
		//console.log("itemsLookup = " + JSON.stringify(this.itemsLookup));
	};

	this.checkAndUpdateSector = function (sector, startAngle) {

		if (Object.keys(sector).length == 0) {
			var offset = 22;
			var angle = startAngle + offset;
			var phItemData1 = {
				'type' : 'placeholder',
				'angle' : angle,
				'th_url' : 'img/placeholder.png'
			};
			sector[angle] = phItemData1;

			angle = angle + offset;
			var phItemData2 = {
				'type' : 'placeholder',
				'angle' : angle,
				'th_url' : 'img/placeholder.png'
			};
			sector[angle] = phItemData2;

			angle = angle + offset;
			var phItemData3 = {
				'type' : 'placeholder',
				'angle' : angle,
				'th_url' : 'img/placeholder.png'
			};
			sector[angle] = phItemData3;

		} else if (Object.keys(sector).length == 1) {
			var offset = 32;
			var angle = startAngle + offset;
			var phItemData1 = {
				'type' : 'placeholder',
				'angle' : angle,
				'th_url' : 'img/placeholder.png'
			};
			sector[angle] = phItemData1;

			angle = angle + offset;
			var phItemData2 = {
				'type' : 'placeholder',
				'angle' : angle,
				'th_url' : 'img/placeholder.png'
			};
			sector[angle] = phItemData2;
		} else if (Object.keys(sector).length == 2) {
			var offset = 45;
			var angle = startAngle + offset;
			var phItemData1 = {
				'type' : 'placeholder',
				'angle' : angle,
				'th_url' : 'img/placeholder.png'
			};
			sector[angle] = phItemData1;
		}

	};

	this.processSector = function (sector) {
		//	console.log("sector = " + JSON.stringify(sector));
		var keys = Object.keys(sector);
		//console.log("keys = " + JSON.stringify(keys));
		keys.sort(function (a, b) {
			return a > b
		});
		//console.log("keys sorted = " + JSON.stringify(keys));

		for (var key in keys) {
			var angle = keys[key];
			//	console.log("processing key =" + angle);
			var item = sector[angle];
			//	console.log("processing item =" + JSON.stringify(item));
			if (item['type'] != 'placeholder') {
				this.selectableItems.push(item);
				item['selectableIndex'] = this.selectableItems.length;
			}
			this.items.push(item);
			item['index'] = this.items.length;
			var itemsAtAngle = this.itemsLookup[angle];
			if (!itemsAtAngle) {
				itemsAtAngle = [];
				this.itemsLookup[angle] = itemsAtAngle;
			}
			itemsAtAngle.push(item);

		}
	};

	this.createScannerDOM = function () {
		//	var slider = $("#top-slider");
		//	for (var key in this.selectableItems) {
		//console.log("processing key =" + key);
		//		this.appendListItemDOMTop(this.selectableItems[key], slider);
		//	}

		var contentSlider = $("#content-slider");
		for (var key in this.items) {
			//console.log("processing key =" + key);
			this.appendListItemDOM(this.items[key], contentSlider);
		}

	};

	this.appendListItemDOMTop = function (item, contentSlider) {
		var li = jQuery('<li/>', {}).appendTo(contentSlider);

		var img = jQuery('<img/>', {
				//id : 'foo',
				src : item['url'],
			}).appendTo(li);

		//console.log("contentSlider = " + JSON.stringify(contentSlider));
	};

	this.appendListItemDOM = function (item, contentSlider) {
		var li = jQuery('<li/>', {}).appendTo(contentSlider);
		var text = ''
			if (item.type != 'placeholder' && item.distance) {
				text = item.distance;
				var div = jQuery('<div/>', {
						//id : 'foo',
						//src : item['th_url'],
						class : 'slider_item_distance',
						text : text
					}).appendTo(li);

				var a = jQuery('<a/>', {
						href : '#',
						target_id : item.id,
					}).appendTo(li);

				$(a).attr("data-toggle", "modal");
				$(a).attr("data-target", "#item-details-modal-sm");
				
				var image_span = jQuery('<span/>', {
						//id : 'foo',
						//src : item['th_url'],
						class : 'slider_item_img_span',
					}).appendTo(a);
					
					
				var img = jQuery('<img/>', {
						//id : 'foo',
						src : item['th_url'],
						class : 'slider_img',
						//title : '',
					})
					.appendTo(image_span);
					
							
				var title_span = jQuery('<span/>', {
						//id : 'foo',
						//src : item['th_url'],
						class: 'slider_item_title_span',
					}).appendTo(a);

				var title = jQuery('<span/>', {
						//id : 'foo',
						text: item['name'],
						class: 'slider_item_title',
					}).appendTo(title_span);	
					
			} else {
					var image_span = jQuery('<span/>', {
						//id : 'foo',
						//src : item['th_url'],
						class : 'slider_item_img_span',
					}).appendTo(li);
					
			
				var img = jQuery('<img/>', {
						//id : 'foo',
						src : item['th_url'],
						class : 'slider_img',
						//title : '',
					})
					.appendTo(image_span);

			}

			img['selectableIndex'] = item['selectableIndex'];

		//console.log("contentSlider = " + JSON.stringify(contentSlider));
	};

	this.getNextItemIndex = function (angle) {

		for (i = 0; i <= 45; i++) {
			// console.log("getNextItemIndex =" + i);
			var key = angle + i;
			if (i < 0)
				key = 360 + i;
			else if (i > 360)
				key = i - 360;

			var item = this.itemsLookup[key];
			if (item) {
				return item['index'];
			}
			key = angle - i;
			if (i < 0)
				key = 360 + i;
			else if (i > 360)
				key = i - 360;

			var item = this.itemsLookup[key];
			if (item) {
				return item['index'];
			}
		}

	};

	this.getNextItem = function (angle) {

		for (i = 0; i <= 45; i++) {
			// console.log("getNextItemIndex =" + i);
			var key = angle + i;
			if (i < 0)
				key = 360 + i;
			else if (i > 360)
				key = i - 360;

			var items = this.itemsLookup[key];
			if (items && items.length > 0) {
				return items[0];
			}
			key = angle - i;
			if (i < 0)
				key = 360 + i;
			else if (i > 360)
				key = i - 360;

			var items = this.itemsLookup[key];
			if (items && items.length > 0) {
				return items[0];
			}
		}
	};

	this.getItemsNumber = function () {
		return this.items.length;
	};

}