function NavItemFLayer(vectorItem, data) {
	this.staticMarkersJSON = appConnector.staticMarkersJSON;
	//this.pbMarkersJSON = data.pbMarkersJSON;
	this.activePBMarkersJSON = appConnector.activePBMarkersJSON;
	this.eventsJSON = appConnector.eventsJSON;
	//console.log('this.pbMarkersJSON ' +this.pbMarkersJSON);
	//console.log('this.activePBMarkersJSON ' +this.activePBMarkersJSON );
	this.vectorItem = vectorItem;
	this.eventsDataByDay = {
		'0' : [],
		'1' : [],
		'2' : [],
		'3' : [],
		'4' : [],
		'5' : [],
		'6' : []
	};
	this.boundItemsData={};
	this.boundItemsData_Location={};
	
	
	this.loadEvents = function () {
		this.eventsData = this.eventsJSON;
		for (var key in this.eventsData) {
			var eventData = this.eventsData[key];

			eventData.start_time_sec = getSecondsFromDayStart(this.parseTime(eventData.start_time));
			//console.log("eventData.start_time " + eventData.start_time + '>' + eventData.start_time_sec);
			for (var d in eventData.days) {
				var day = eventData.days[d];
				this.eventsDataByDay[day].push(eventData)
				var itemData = this.boundItemsData_Location[eventData.location_id];
				if (itemData) {
					if (!itemData.relatedEvents) {
						itemData.relatedEvents = {}
					}
					if (!itemData.relatedEvents[day])
						itemData.relatedEvents[day] = [];
					itemData.relatedEvents[day].push(eventData.id);

				}
			}
		}
			// pre-sort day events
		for (var d in this.eventsDataByDay) {
			var dayEvents = this.eventsDataByDay[d];
			this.eventsDataByDay[d] = dayEvents.sort(
					function (a, b) {
					return  (a.start_time_sec > b.start_time_sec) ? 1 : (a.start_time_sec < b.start_time_sec) ? -1 : 0;
				});

		}
		//console.log("this.eventsDataByDay" +JSON.stringify(this.eventsDataByDay));
		//console.log("this.eventsDataByDay" +JSON.stringify(this.eventsDataByDay));
		// pre-sort item day events

		for (var key in this.eventsData) {
			var eventData = this.eventsData[key];
			var itemData = this.boundItemsData_Location[eventData.location_id];
			if (itemData && itemData.relatedEvents)
				for (var d in itemData.relatedEvents) {
					var dayEvents = itemData.relatedEvents[d];
					itemData.relatedEvents[d] = dayEvents.sort(
							function (a, b) {
							return  (a.start_time_sec > b.start_time_sec) ? 1 : (a.start_time_sec < b.start_time_sec) ? -1 : 0;
						});
				//console.log("event time " +JSON.stringify(itemData.relatedEvents[d]));
				}

		}
	}

	this.getNextEvent = function (itemID) {
		var d = new Date();
		var day = d.getDay();
		var currentTimeFromDayStart = getSecondsFromDayStart(d);
		var itemData = this.boundItemsData[itemID];
		if (itemData.relatedEvents && itemData.relatedEvents[day])
			for (var key in itemData.relatedEvents[day]) {
				var eventID = itemData.relatedEvents[day][key];
				//console.log("eventid" + eventID);
				var eventData = this.eventsData[eventID];
				//console.log("event time " + eventData.start_time_sec + " current " + currentTimeFromDayStart);
				if (eventData.start_time_sec >= currentTimeFromDayStart) {
				//	console.log("event time " + eventData.start_time_sec + " current " + eventData.start_time_sec);
					return eventData;
				}

			}

		return;

	}

	/**
	 * Parse a time in nearly any format
	 * @param {string} time - Anything like 1 p, 13, 1:05 p.m., etc.
	 * @returns {Date} - Date object for the current date and time set to parsed time
	 */
	this.parseTime = function (time) {
		var b = time.match(/\d+/g);

		// return undefined if no matches
		if (!b)
			return;

		var d = new Date();
		d.setHours(b[0] > 12 ? b[0] : b[0] % 12 + (/p/i.test(time) ? 12 : 0), // hours
			/\d/.test(b[1]) ? b[1] : 0, // minutes
			/\d/.test(b[2]) ? b[2] : 0); // seconds
		return d;
	}

	this.loadNavItems = function () {
		//console.log('loadNavItems');
		if (this.staticMarkersJSON)
			this.staticItemsData = this.staticMarkersJSON;
		else
			this.staticItemsData = {};

		if (this.activePBMarkersJSON)
			this.activePBItemsData = this.activePBMarkersJSON;
		else
			this.activePBItemsData = {};

		// resolve  markers data
	    var loadLast=[];
		for (var key in this.staticItemsData) {
			var itemData = this.staticItemsData[key];
			//console.log('marker_type: ' + itemData["marker_type"]);
			if (itemData["marker_type"]=='stop') {
					
				loadLast.push(itemData)
			} else {
					if (itemData["location_id"]) {
			//	console.log('itemData["location_id"]: ' + itemData["location_id"]);
					var activeItemData = this.activePBItemsData[itemData["location_id"]];
					if (activeItemData) {
						var completeMarkerData=$.extend(true, {}, itemData, activeItemData)
					//	completeMarkerData.id = itemData.id;
					//	console.log('itemData: ' + JSON.stringify(itemData));
					//	console.log('activeItemData: ' + JSON.stringify(activeItemData));
					//	console.log('completeMarkerData: ' + JSON.stringify(completeMarkerData));
						this.loadMarkerData(completeMarkerData);
						this.boundItemsData_Location[itemData["location_id"]]=completeMarkerData;
					}
				} else {
					this.loadMarkerData(itemData);
				}
					
			}
			

		}
		for (var key in loadLast) {
			var itemData = loadLast[key];
				//console.log('itemData: ' + JSON.stringify(itemData));
					if (itemData["location_id"]) {
			//	console.log('itemData["location_id"]: ' + itemData["location_id"]);
					var activeItemData = this.activePBItemsData[itemData["location_id"]];
					if (activeItemData) {
						var completeMarkerData=$.extend(true, {}, itemData, activeItemData)
					//	completeMarkerData.id = itemData.id;
					//	console.log('itemData: ' + JSON.stringify(itemData));
					//	console.log('activeItemData: ' + JSON.stringify(activeItemData));
					//	console.log('completeMarkerData: ' + JSON.stringify(completeMarkerData));
						this.loadMarkerData(completeMarkerData);
						this.boundItemsData_Location[itemData["location_id"]]=completeMarkerData;
					}
				} else {
					this.loadMarkerData(itemData);
				}
			
			

		}

		console.log(this.boundItemsData['SM22590'] );
	}



	this.generateTestData = function() {
		var i = 0;
		for (var key in markerOptions) {
			i++;
			var markerName = markerOptions[key];
			console.log(markerName)
			var itemData = {
				popupHeading: markerName,
				marker_type: markerName,
				type: "st-marker",
				"gType": "Point",
				coord: [viewableBounds[0] + i * 100, viewableBounds[1] + 100]

			}
			navigatorCore.navItemFLayer.loadMarkerData(itemData);

		}
	}
	
	this.loadMarkerData = function (itemData){
		//console.log(itemData.id );
			this.boundItemsData[itemData.id] = itemData;
			if(itemData['auxData']=='tour'){
				itemData['marker_type'] = itemData['marker_type'] +"_tour";
			}
			if (!itemData['popupPreviewURL']) {
				var marker_type = itemData['marker_type'];
				if(markerStyles[marker_type])
				itemData['popupPreviewURL'] = markerStyles[marker_type]['default_preview']
				else 
				itemData['popupPreviewURL'] = markerStyles["general"]['default_preview']
			}

			if (itemData['gType'] == 'Point') {
				//console.log('loadPoint ');
  
				var marker = createIconMarker(itemData['coord'], itemData['id'], itemData['id'],itemData['marker_type']);
				marker.setId(itemData['id']);

				//marker.setStyle(iconMarkerStyle);
				vectorItem.getSource().addFeature(marker);
				itemData['feature'] = marker;

			} 
			
            if(itemData['popupHeadingIntl'] ) itemData['popupHeading'] =itemData['popupHeadingIntl'] [language]
			if(! itemData['popupHeading'])  itemData['popupHeading']='';
			if(itemData['popupTextIntl'] ) itemData['popupText'] = itemData['popupTextIntl'] [language]
			  

	
	
	}
	

	this.getNavBindingOptionsForItem = function (item_id) {
		var navBindingOptions = [];
		var itemData = this.boundItemsData[item_id];
		if (!itemData['links-bbn'] || !Object.keys(itemData['links-bbn']).length > 0  ) {
		if(!itemData["destLocation"]) 
			itemData["destLocation"] = navigatorCore.getDestinationLocation(itemData['coord']);
		navBindingOptions.push(itemData["destLocation"]);
		return navBindingOptions;
		}
		//console.log("itemData " + JSON.stringify(itemData));
		var links_bbn;
		
		if (itemData && itemData.type == "pb-marker") {
			var itemDataB = this.boundItemsData[item_id];
			if (itemDataB)
				links_bbn = itemDataB['links-bbn'];
		} else if (itemData && itemData.type=="st-marker")
			links_bbn = itemData['links-bbn'];
		
		//console.log("links_bbn " + links_bbn);
		for (var key in links_bbn) {
			var linkData = links_bbn[key];
			if (linkData["type"] == "link-bbn") {
				var destinationPoint_id = linkData["destNode"];
				var nav_node = navigatorCore.navBackboneFLayer.points[destinationPoint_id];
				if(nav_node){
				var result = {};
				result['itemData'] = itemData;
				result['itemCoord'] = itemData['coord'];
				result['coord'] = nav_node['coord'];
				result['feature'] = navigatorCore.navBackboneFLayer.featuresLoadCache[destinationPoint_id];
				navBindingOptions.push(result);
				}
			} else if (linkData["type"] == "connect-node-bbl") {
				var hostLink_id = linkData['hostLink'];
				var result = {};
				result['itemData'] = itemData;
				result['itemCoord'] = itemData['coord'];
				result['coord'] = linkData["coord"];
				result['feature'] = navigatorCore.navBackboneFLayer.featuresLoadCache[hostLink_id];
				navBindingOptions.push(result);
			}
		}
		return navBindingOptions;
	}
	
	this.bindingOptionDirectRoute = function (startLocation, destBindingOption) {
		var point1 = destBindingOption['coord']
		var point2 = destBindingOption['itemCoord']
		var tempLink = this.createTempLink(point1, point2);
		//vectorItem.getSource().addFeature(tempLink);
		var closestPoint = tempLink.getGeometry().getClosestPoint(startLocation.startCoord);
		var test = this.createTempNode(closestPoint)
		
		vectorItem.getSource().addFeature(test);
	//	vectorItem.getSource().removeFeature(tempLink);
		var shortestPath = {};
		var routingData = {};
		routingData['d'] = 0;
		routingData['p'] = [];
		shortestPath['startLocation'] = startLocation;
		shortestPath['destinationLocation'] = destBindingOption;
		shortestPath['routingData'] = routingData;
		shortestPath['closestPoint'] = closestPoint;
		shortestPath['d'] = this.getDistance(startLocation.startCoord, closestPoint) + this.getDistance(closestPoint, point2);

		return shortestPath;
	}
	this.getDistance = function (coord1, coord2) {
		return Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2));
	}

	this.getDistanceSqr = function (coord1, coord2) {
		return Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2);
	}
	
	this.createTempLink = function (coord1, coord2) {
	var linkFeature =
			new ol.Feature({
				type : 'temp-link',
				geometry : new ol.geom.LineString([coord1,coord2]),

			});
		return linkFeature;
	}

this.createTempNode = function (coord1) {
	var linkFeature =
			new ol.Feature({
				type : 'temp-node',
				geometry : new ol.geom.LineString(coord1),

			});
		return linkFeature;
	}
	
	
this.searchByTerm = function (term) {
	var regExpr = new RegExp(term, "i");
   console.log(regExpr);
	// search static and dynamic markers
	var items=[];
	for (var key in this.boundItemsData) {
		var itemData = this.boundItemsData[key];
		var selected =false;
		if(itemData['popupHeading']){
			if(itemData['popupHeading'].search(regExpr)!=-1) selected=true;
	
		}
		if(itemData['popupText']){
			if(itemData['popupText'].search(regExpr)!=-1) selected=true;
		}	
		if(itemData['marker_type']){
			if(itemData['marker_type'].search(regExpr)!=-1) selected=true;
	
		}
		if(selected){
			 items.push(itemData);
		}
	}
	
// search events - implement;
	//items.sort(function(a, b){
	// var nameA=a.popupHeading.toLowerCase(), nameB=b.popupHeading.toLowerCase();
	// if (nameA < nameB) //sort string ascending
//	  return -1;
//	 if (nameA > nameB)
//	  return 1;
//	 return 0; //default return value (no sorting)
	//});

	
		 items.sort(function(a, b){
	 var distA=navigatorCore.findDistanceToItem(a['id']);
  	 var distB=navigatorCore.findDistanceToItem(b['id']);
	 if (distA < distB) //sort string ascending
	  return -1;
	 if (distA > distB)
	  return 1;
	 return 0; //default return value (no sorting)
	});
	return {'items':items}

}

this.searchByType = function (typeOptions, strict,keyword) {
	//console.log(regExpr);
	// search static and dynamic markers
	var regexCache = {};
	var items = [];
	for (var key in this.boundItemsData) {
		var itemData = this.boundItemsData[key];
		var selected = false;
		if (itemData['marker_type']) {
			for (var keyType in typeOptions) {
				var type = typeOptions[keyType];
				if (strict) {
					
					if (itemData['marker_type'] == type )
						selected = true;
				} else {
					var regExpr = regexCache[type];
					if (!regExpr) {
						regExpr = new RegExp(type, "i");
						regexCache[type] = regExpr;
					}
					if(itemData['marker_type'].search(regExpr)!=-1) selected=true;
				}

			}
		}
		if (selected) {
			items.push(itemData);
		}
	}
	//console.log("items " + items);
	var final_items=items;
	if (keyword) {
		final_items=[];
		var regExpr = new RegExp(keyword, "i");
		var final_items = [];
		for (var key in items) {
			var itemData = items[key];
			var selected = false;
			if (itemData['popupHeading']) {
				if (itemData['popupHeading'].search(regExpr) != -1)
					selected = true;

			}
			if (itemData['popupText']) {
				if (itemData['popupText'].search(regExpr) != -1)
					selected = true;
			}
			if (itemData['marker_type']) {
				if (itemData['marker_type'].search(regExpr) != -1)
					selected = true;

			}
			if (selected) {
				final_items.push(itemData);
			}
		}

	}
	
	// search events - implement;
	// final_items.sort(function(a, b){
	// var nameA=a.popupHeading.toLowerCase(), nameB=b.popupHeading.toLowerCase();
	// if (nameA < nameB) //sort string ascending
	//  return -1;
	// if (nameA > nameB)
//	  return 1;
//	 return 0; //default return value (no sorting)
//	});
	
	
	 final_items.sort(function(a, b){
	 var distA=navigatorCore.findDistanceToItem(a['id']);
  	 var distB=navigatorCore.findDistanceToItem(b['id']);
	 if (distA < distB) //sort string ascending
	  return -1;
	 if (distA > distB)
	  return 1;
	 return 0; //default return value (no sorting)
	});

	return {
		'items' : final_items
	}

}

this.searchTour = function (sortedTourItems, strict,keyword) {
	//console.log(regExpr);
	// search static and dynamic markers
	var regexCache = {};
	
	//console.log("items " + items);
	var items = sortedTourItems;
	var final_items=sortedTourItems;
	if (keyword) {
		final_items=[];
		var regExpr = new RegExp(keyword, "i");
		var final_items = [];
		for (var key in items) {
			var itemData = items[key];
			var selected = false;
			if (itemData['popupHeading']) {
				if (itemData['popupHeading'].search(regExpr) != -1)
					selected = true;

			}
			if (itemData['popupText']) {
				if (itemData['popupText'].search(regExpr) != -1)
					selected = true;
			}
			if (itemData['marker_type']) {
				if (itemData['marker_type'].search(regExpr) != -1)
					selected = true;

			}
			if (selected) {
				final_items.push(itemData);
			}
		}

	}
	

	return {
		'items' : final_items
	}

	}	

	this.tempEnableViewMoreLink = function () {

		for (var key in this.boundItemsData) {
			var itemData = this.boundItemsData[key];
			itemData['location_id'] = "test12345";

		}
	}
}