var vectorSourceTrack;
var vectorLayerTrack;
var trackAssistant;
var ignoreLock=false;

function initTrackAssistant(track) {
	$("#station_overlay_top").hide();
	$("#station_overlay_bottom").hide()
	if (!vectorSourceTrack && !vectorLayerTrack) {
		vectorSourceTrack = new ol.source.Vector({});
		vectorLayerTrack = new ol.layer.Vector({
				source: vectorSourceTrack
			});
		map.addLayer(vectorLayerTrack);
	}
	trackAssistant = new TrackAssistant(navigatorCore, vectorLayerTrack)
	trackAssistant.initForPath(track);
}


function TrackAssistant(navigatorCore, vectorNav) {
	this.vectorNav = vectorNav;
	this.navigatorCore = navigatorCore;
	this.isActive = false;
	this.pathFeatures = [];
	this.pathDirections = [];
	this.deviceOrientationDirections = [];
	this.currentDirections = {};
	this.arrived = false;
	this.approaching = false;
	this.outbound = true;
	this.onPath = 500
	this.aproachingNodeDist = 200;
	this.projectedUserLocationDisplay =  new ProjectedUserLocationDisplay(navigatorCore)
	this.projectedUserLocationDisplay.initCoordPopupDisplay();
	this.unknown=0;
	this.outbound=1;
	this.inbound=2;
	
	this.initForPath = function (track) {
				var currentZoomLevel;

		map.on('moveend', checknewzoom);

		function checknewzoom(evt)
		{
		   var newZoomLevel = map.getView().getZoom();
		   if (newZoomLevel != currentZoomLevel)
		   {
			  currentZoomLevel = newZoomLevel;
			  $(document).trigger("zoomend", evt);
		   }
		}
		/*$(document).on('zoomend', function () {
			var currentZoom = map.getView().getZoom()
			var center = map.getView().getCenter();
			var kurandaBoundsLonLat = [145.625480007668, -16.8278980073737, 145.643737659507, -16.8125814884562]
			var kurandaBounds = ol.proj.transformExtent(kurandaBoundsLonLat, 'EPSG:4326', 'EPSG:3857');
			console.log(ol.extent.containsCoordinate(kurandaBounds, center));
			if (ol.extent.containsCoordinate(kurandaBounds, center) && currentZoom >= 17) {
				//map.getView().fit(kurandaBounds, map.getSize());
				console.log("Zoom Kuranda");
				map.setView(
					new ol.View({
				        center: center,
						extent: kurandaBounds,
						zoom: currentZoom
					}));
			}
			console.log("Zoom");
			//Your code here
		});
		*/
		this.dir = this.unknown;
		this.isActive = true;
		this.pathFeatures = [];
		var pathNodes = [];
		
		var navPath = track;
		for (var i = 0; i < navPath.length; i++) {
			var id = navPath[i];
			var itemData = navigatorCore.navItemFLayer.boundItemsData[id];
			var nodeData = {};
			nodeData['coord'] = itemData['coord'];
			nodeData['name'] = itemData['popupHeading']
			nodeData['popupPreviewURL'] = itemData['popupPreviewURL'];
			nodeData['target_id'] = id;
			pathNodes.push(nodeData);
		}

		// create invisible features
		var k = 0;
		for (var i = 1; i < pathNodes.length; i++) {
			var nodeDataStart = pathNodes[i - 1];
			if (i == 1) {
				var nodeDataStartFeature = this.createPathNodeFeature(nodeDataStart);
				this.pathFeatures.push(nodeDataStartFeature);
				nodeDataStart['feature'] = nodeDataStartFeature;
			}
			var nodeDataEnd = pathNodes[i];
			//calculate angles
			nodeDataStart['nextNode'] = nodeDataEnd;
			nodeDataEnd['prevNode'] = nodeDataStart;

			var pathSegmentLink = this.createPathSegmentFeature(nodeDataStart, nodeDataEnd);
			this.pathFeatures.push(pathSegmentLink);
			var nodeDataEndFeature = this.createPathNodeFeature(nodeDataEnd);
			this.pathFeatures.push(nodeDataEndFeature);
			nodeDataEnd['feature'] = nodeDataEndFeature;

		}
		for (var i = 0; i < pathNodes.length; i++) {
			this.calculateAngles(pathNodes[i]);
		}
		// show path
		for (var i = 0; i < this.pathFeatures.length; i++) {

			vectorNav.getSource().addFeature(this.pathFeatures[i]);

		}

		
		if(this.pathFeatures && this.pathFeatures.length>0) {
				var destCoord = ol.proj.toLonLat((this.pathFeatures[this.pathFeatures.length-1].nodeData['coord']))
				this.currentDirections["lonLat"] = destCoord;
				//console.log('dest'+ JSON.stringify(destCoord))
		} 

	}

	this.setDirection = function (dir) {
		this.dir = dir;
		if ( trackAssistant.dir == 1) {
			$("#btnSetDirection").text('To Kuranda')
		} else if ( trackAssistant.dir == 2) {
			$("#btnSetDirection").text('To Smithfield')
		} else if ( trackAssistant.dir == 0) {
			$("#btnSetDirection").text('')
		}
		this.updateVisibleMarkers();
	}
	
	this.dir_outbound = function () {
		return this.dir == this.outbound;
	}
	this.dir_inbound = function () {
		return this.dir == this.inbound;
	}
	this.dir_unknown = function () {
		return this.dir == this.unknown;
	}
	
		this.updateVisibleMarkers = function () {
		$('#tour_arrived_overlay').hide();
		popupNav.hide();
		var boundItemsData = navigatorCore.navItemFLayer.boundItemsData;
		for (var key in boundItemsData) {
			var itemData = boundItemsData[key];
			if (itemData.feature) {
				//console.log(itemData.outbound )
				if (itemData.outbound || itemData.inbound) {
					var marker_type = itemData.feature.get('marker_type')
						var style = markerStyles[marker_type]['normal'];
					var show = (this.dir_outbound() && itemData.outbound == 1) || (this.dir_inbound() && itemData.inbound == 1)
					if (show) {
						//style.getImage().setOpacity('1');
						itemData.feature.hide = undefined
					} else {
						//style.getImage().setOpacity('0');
						itemData.feature.hide = 1
					}
					itemData.feature.changed();
				}
			}
		}

	}
	/*
	this.updateVisibleMarkers = function () {
		$('#tour_arrived_overlay').hide();
		popupNav.hide();
		var boundItemsData = navigatorCore.navItemFLayer.boundItemsData;
		for (var key in boundItemsData) {
			var itemData = boundItemsData[key];
			if (itemData.feature) {
				//console.log(itemData.outbound )
				if (itemData.outbound || itemData.inbound) {
					var marker_type = itemData.feature.get('marker_type')
						var style = markerStyles[marker_type]['normal'];
					var show = wasLocked && (this.dir_outbound() && itemData.outbound == 1) || (this.dir_inbound() && itemData.inbound == 1)
					if (show) {
						itemData.feature.hide = undefined
					} else {
						itemData.feature.hide = 1
					}
					itemData.feature.changed();
				}
			}
		}

	}
	*/
	this.stopNavigationAssistance = function () {

	}
	
	this.clearNavigationAssistance = function () {
	}
	
	this.updateArrivedOverlay = function () {
	}
	
	this.setArrived = function (flag) {
		this.arrived = flag
		if(this.arrived){

		}

	}
	this.setApproaching = function (flag) {
		this.approaching = flag
	}
	
	this.createPathNodeFeature = function (nodeData) {
		var point = new ol.geom.Point(nodeData['coord']);
		var nodeFeature =
			new ol.Feature({
				type : 'path-node',
				geometry : point,
			});
		nodeFeature['nodeData'] = nodeData;
		nodeFeature.setStyle(this.nodeStyleInvisible);
		return nodeFeature;
	}
	this.createPathNodeFeatureHL = function (nodeData) {
		var point = new ol.geom.Point(nodeData['coord']);
		var nodeFeature =
			new ol.Feature({
				type : 'path-node',
				geometry : point,
			});
		nodeFeature['nodeData'] = nodeData;
		nodeFeature.setStyle(this.nodeStyleHL);
		return nodeFeature;
	}
	this.nodeStyleHL = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 9,
				fill : new ol.style.Fill({
					color : 'rgba(0, 255, 0, 0)'
				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(0, 255, 0, 0)',
					width : 2
				})
			})
		});
	this.nodeStyleInvisible = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 7,
				fill : new ol.style.Fill({
					color : 'rgba(255, 0, 0, 0)'
				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(255, 0, 0,0)',
					width : 2
				})
			})
		});

	this.linkStyleInvisible = new ol.style.Style({
			stroke : new ol.style.Stroke({
				color : 'rgba(255, 0, 0, 0)',
				width : 1

			})
		});

	this.createPathSegmentFeature = function (nodeDataStart, nodeDataEnd) {
		//console.log("nodeDataStart " + nodeDataStart['coord']);
		//console.log("nodeDataEnd " + nodeDataEnd['coord']);
		var linkFeature =
			new ol.Feature({
				//id:   'linkFeature',
				type : 'path-link',
				geometry : new ol.geom.LineString([nodeDataStart['coord'], nodeDataEnd['coord']]),
				name : 'link'
			});
		//nodeFeature.setId(startNode.getId());
		linkFeature['nodeDataStart'] = nodeDataStart;
		linkFeature['nodeDataEnd'] = nodeDataEnd;
		linkFeature.setStyle(this.linkStyleInvisible);
		return linkFeature;

	}

	this.calculateAngles = function (nodeData) {
		// get angle relative to axis Y
		//angle(v1, v2) = acos( (v1x * v2x + v1y * v2y) / (sqrt(v1x^2+v1y^2) * sqrt(v2x^2+v2y^2)) )

		var nextNode = nodeData['nextNode'];
		if (nextNode) {
			// get angle to axis y;

			var v1 = {
				'x' : 0,
				'y' : 100
			}
			var v2 = {
				'x' : nextNode['coord'][0] - nodeData['coord'][0],
				'y' : nextNode['coord'][1] - nodeData['coord'][0]

			}

			//var result = this.calculateAngle2Vectors(v1,v2);
			var results = this.calculateAngle2Vectors2(nodeData['coord'], nextNode['coord']);
			nodeData['angleX'] = results;
			//console.log("angle degrees to X " + results.angleDeg);
			var prevNode = nodeData['prevNode'];
			if (prevNode) {
				var turnAngle = -nodeData['angleX'].angleDeg + prevNode['angleX'].angleDeg;
				if (Math.abs(turnAngle) > 180) {
					if (360 + turnAngle < 180)
						turnAngle = 360 + turnAngle;
					else
						turnAngle = turnAngle - 360;

				}
				results['angleTurnDeg'] = turnAngle;
				//console.log("angle turn X " + turnAngle);
			}

		}
	}

	this.calculateAngle2Vectors = function (v1, v2) {
		//angle(v1, v2) = acos( (v1x * v2x + v1y * v2y) / (sqrt(v1x^2+v1y^2) * sqrt(v2x^2+v2y^2)) )
		var angleRad = Math.acos((v1.x * v2.x + v1.y * v2.y) / (Math.sqrt(Math.pow(v1.x, 2) + Math.pow(v1.y, 2)) * Math.sqrt(Math.pow(v2.x, 2) + Math.pow(v2.y, 2))));
		var angleDeg = angleRad * 180 / Math.PI;
		var angle = {
			'angleRad' : angleRad,
			'angleDeg' : angleDeg,
		}
		return angle;

	}

	this.calculateAngle2Vectors2 = function (start, end) {
		//angle(v1, v2) = acos( (v1x * v2x + v1y * v2y) / (sqrt(v1x^2+v1y^2) * sqrt(v2x^2+v2y^2)) )

		var x = start[0] + (end[0] - start[0]) / 2;
		var y = start[1] + (end[1] - start[1]) / 2;
		//arrow.setId('arrow');
		var dx = end[0] - start[0];
		var dy = end[1] - start[1];
		var angleRad = Math.atan2(dy, dx);
		var angleDeg = angleRad * 180 / Math.PI;
		//console.log(angleDeg);
		var angleDegInverted = angleDeg * (-1)

			if (this.sign(angleDegInverted) == -1) {
				angleDegDO = 360 + angleDegInverted + 90
			} else {
				angleDegDO = angleDegInverted + 90
			}

			if (angleDegDO > 360)
				angleDegDO = angleDegDO - 360;

			//console.log(angleDegInverted + " > " + angleDegDO);

			var angle = {
			'angleRad' : angleRad,
			'angleRadInverted' : angleDegDO * Math.PI / 180,
			'angleDeg' : angleDeg,
			'angleDegDO' : angleDegDO,
		}
		return angle;

	}
	
	 this.sign = function(x) {
	  x = +x; // convert to a number
	  if (x === 0 || isNaN(x)) {
		return x;
	  }
	  return x > 0 ? 1 : -1;
	}
	
	this.userLocationChanged = function (newLocation) {
		if (this.isActive && !this.arrived ) {
			this.updatePathDirectionsOnLocationChanged(newLocation);
		}

	}

	
	this.getCurrentDirections = function () {
		return this.currentDirections;
	}
	
	this.updateDisplayedDirections = function () {
		//	document.getElementById('o_dir').innerText = '';
		//	document.getElementById('p_dir').innerText ='';
		$('#nav_distance').show();
		$('#nav_time').show();	
		this.currentDirections['nav_direction_curent'] = undefined;
		this.currentDirections['nav_direction_next'] = undefined;
		this.currentDirections['path_summary'] = undefined;
		
		
		$('#tour-nav-link').text(tourName);
		$("#nav_current_image").attr('class', 'no_arrow');
		$('#nav_current_text').text('');
		$("#nav_next_image").attr('class', 'no_arrow');
		$('#nav_next_text').text('');
		var hasCurrent = false;
		
			//	var s = '';
			

		if ( this.arrived){
			return;
		}
		
			

			if (this.deviceOrientationDirections.length > 0) {
				hasCurrent = true;
				//	document.getElementById('o_dir').innerText = JSON.stringify(this.deviceOrientationDirections[0]);
				$("#nav_current_image").attr('class', this.deviceOrientationDirections[0].type);
				$("#nav_current_image").addClass('d_' + this.deviceOrientationDirections[0].turn);
				$('#nav_current_text').text(this.deviceOrientationDirections[0].text);
				this.currentDirections['nav_direction_curent'] =this.deviceOrientationDirections[0];
			}
			//console.log(JSON.stringify(this.pathDirections))
			if (this.pathDirections.length > 0) {
			//	var s = '';
				for (var i = 0; i < this.pathDirections.length; i++) {
					var directions = this.pathDirections[i]
						//s = s + JSON.stringify(directions);

						if (!hasCurrent) {
							$("#nav_current_image").attr('class', directions.type);
							if (directions.type == "turn" ) {
								$("#nav_current_image").addClass('d_' + directions.turn);
								$('#nav_current_text').text(directions.text);
							}
							if (directions.type == "walk") {
								$('#nav_current_text').text(directions.distance + 'm');
							}
							if (directions.type == "arrive") {
								$('#nav_current_text').text(directions.text);
							}
							if (directions.type == "walk_to_path") {
								$('#nav_current_text').text(directions.text);
							}
							this.currentDirections['nav_direction_curent'] = directions;
							hasCurrent = true;
						
						} else {
							$("#nav_next_image").attr('class', directions.type);
							$('#nav_next_text').text(langString (language, 'direction_then'));
							if (directions.type == "turn") {
								$("#nav_next_image").addClass('d_' + directions.turn);

							}
							this.currentDirections['nav_direction_next'] = directions;
							break;
						}
				}
				//document.getElementById('p_dir').innerText =s;
			}

			// display path summary

			if (this.pathSummary) {
				$('#nav_distance').text(this.pathSummary.distanceMeters + "m");
				$('#nav_time').text(this.pathSummary.timeSecondsDisplay);
				$('#nav_arrival').text(this.pathSummary.arrivalTimeDisplay);
				this.currentDirections['path_summary'] = this.pathSummary;
			}
			var lastKnownLocation = this.navigatorCore.locationManager.getLastKnownLocation();
			if (lastKnownLocation) {
			 this.currentDirections['last_known_location'] = ol.proj.toLonLat(lastKnownLocation);
			 this.currentDirections['positioning_mode'] =  this.navigatorCore.positioningMode;
			}
			
//var result = appConnector.getCurrentNavDirections();
//console.log(JSON.stringify(result));
	}

	this.createOrientationDirectionsOnPath = function (newDeviceRotation) {
		//alert('dir');
		if (this.currentClosestfeatures) {

			var nodeDataStart = this.currentClosestfeatures.link.feature.nodeDataStart;
			if (this.aproachingNode) {
				nodeDataStart = this.currentClosestfeatures.node.feature.nodeData;
			}
			var angleX = nodeDataStart['angleX'];
			//var m =this.createPathNodeFeatureHL(this.currentClosestfeatures.link.feature.nodeDataStart);
			//vectorNav.getSource().addFeature( m);
			if (angleX) {
				var angleDegDO = angleX['angleDegDO'];
				var relAngle = newDeviceRotation - angleDegDO;

				if (Math.abs(relAngle) > 180) {
					relAngle = (-1) * this.sign(relAngle) * (360 - Math.abs(relAngle));
				}

				//	document.getElementById('debug').innerText = angleDegDO;
				//	document.getElementById('debug1').innerText = relAngle;
				if (Math.abs(relAngle) > this.navigatorCore.orientationTrigger ) {
					var turnDirection = this.createTurnDirectionOrientation(-relAngle);
					this.deviceOrientationDirections.push(turnDirection);
				}
			}
		}  
	}

	this.createOrientationDirectionsNotOnPath = function (newDeviceRotation) {
		if (this.currentClosestfeatures) {
			var feature = this.currentClosestfeatures.link.feature;
			var userLocation = this.navigatorCore.locationManager.getLastKnownLocation();
			var closestPoint = feature.getGeometry().getClosestPoint(userLocation);
			if (userLocation) {
				var angleX = this.calculateAngle2Vectors2(userLocation, closestPoint);
				//var m =this.createPathNodeFeatureHL(this.currentClosestfeatures.link.feature.nodeDataStart);
				//vectorNav.getSource().addFeature( m);

				var angleDegDO = angleX['angleDegDO'];
				var relAngle = newDeviceRotation - angleDegDO;

				if (Math.abs(relAngle) > 180) {
					relAngle = (-1) * this.sign(relAngle) * (360 - Math.abs(relAngle));
				}
				//	document.getElementById('debug').innerText = angleDegDO;
				//	document.getElementById('debug1').innerText = relAngle;
				if (Math.abs(relAngle) > this.navigatorCore.orientationTrigger) {
					var turnDirection = this.createTurnDirectionOrientation(-relAngle);
					this.deviceOrientationDirections.push(turnDirection);
				}
			}
		}

	}

	this.updatePathDirectionsOnLocationChanged = function (newLocation) {
		if(ignoreLock) return;
		this.pathDirections = [];
		this.pathSummary = {};
		var closestFeatures = this.getClosestPathFeatures(newLocation);
		this.currentClosestfeatures = closestFeatures

		this.isOnPath = closestFeatures.link.closetDistance * this.navigatorCore.mapMetersPerCoordinatePoint < this.onPath ;
		//|| closestFeatures.node.closetDistance * this.navigatorCore.mapMetersPerCoordinatePoint < this.navigatorCore.onPath

		//	console.log("isOnPath" + closestFeatures.node.closetDistance * this.navigatorCore.mapMetersPerCoordinatePoint );
		//	console.log("isOnPath" + closestFeatures.link.closetDistance * this.navigatorCore.mapMetersPerCoordinatePoint );
		if (this.isOnPath) {
			//console.log("isOnPath");
			// on path pathDirections
			var distanceToNodeAlongPath = this.getDistanceMeteres(closestFeatures.link.closestPoint, closestFeatures.node.closestPoint);
			//console.log("node dist" + closestFeatures.node.closetDistance * this.navigatorCore.mapMetersPerCoordinatePoint);
			this.aproachingNode = distanceToNodeAlongPath < this.aproachingNodeDist ;
			//
			if (this.aproachingNode) {
				// node direction
				//console.log("aproachingNode");
				//this.updatePathDirectionsNode(closestFeatures.node.feature.nodeData);
			 this.lockMapStation(closestFeatures.node);
			
			} else if (!this.dir_unknown()){
				// link direction
			 this.lockMapOnLink(closestFeatures.link)
			//	this.updatePathDirectionsLink(closestFeatures.link.closestPoint, closestFeatures.link.feature.nodeDataEnd);
				//console.log("near link");
				//console.log("pathDirections" + JSON.stringify(this.pathDirections));
			}

		} else {
			// get to  path pathDirections
			//console.log("not on path");
			//this.updatePathDirectionsNotOnPath(newLocation, closestFeatures.link.closestPoint);
			//console.log("pathDirections" + JSON.stringify(this.pathDirections));
			this.unlockMap()
		}
		var distance;
		if (this.isOnPath) 
			distance = closestFeatures.link.closetDistance + this.getDistance(closestFeatures.link.closestPoint, closestFeatures.node.closestPoint);
		else 
			distance = closestFeatures.link.closetDistance +  this.getDistance(closestFeatures.link.closestPoint, closestFeatures.node.closestPoint);
		var nodeData = closestFeatures.node.feature.nodeData;
		while (nodeData.nextNode) {
			distance = distance + this.getDistance(nodeData.coord, nodeData.nextNode.coord);
			nodeData = nodeData.nextNode;
		}
		this.pathSummary.distanceMeters = Math.round(distance * this.navigatorCore.mapMetersPerCoordinatePoint);
		this.pathSummary.timeSeconds = Math.round(this.pathSummary.distanceMeters / this.navigatorCore.avarageWalkingSpeed);

		this.pathSummary.timeSecondsDisplay = displayTimeFromSecondsRounded(this.pathSummary.timeSeconds);

		//var date = new Date(null);
		//date.setSeconds(this.pathSummary.timeSeconds);
		//this.pathSummary.timeSecondsDisplay=date.toISOString().substr(11, 8);

		var arrivalDate = new Date((new Date().getTime() + 1000 * this.pathSummary.timeSeconds));
		var arrivalTimeDisplay = arrivalDate.getHours() + ":"
			 + arrivalDate.getMinutes() + ":"
			 + arrivalDate.getSeconds();

		this.pathSummary.arrivalTime = arrivalDate.getTime();
		this.pathSummary.arrivalTimeDisplay = arrivalTimeDisplay;

		//if (this.pathSummary.distanceMeters <= this.navigatorCore.arrivedDistance)
		//	this.setArrived(true);	
		//if (this.pathSummary.distanceMeters <= this.navigatorCore.approachingDistance)
		//	this.setApproaching(true);
	//	else this.setApproaching(false);
		this.updateDisplayedDirections();
		this.updateArrivedOverlay();

	}

	this.lockMapOnLink = function (link) {
		//console.log("lockMapOnLink " + link.feature.nodeDataStart.name)
		//	console.log("lockMapOnLink " + link.feature.nodeDataEnd.name)
		currentRad = map.getView().getRotation();
		setMode(mode_unlockAndRotateIcon);
		if (this.dir_outbound()) {
			this.currentNodeDataStart = link.feature.nodeDataStart
				this.currentNodeDataEnd = link.feature.nodeDataEnd
		} else if (this.dir_inbound()) {
			this.currentNodeDataStart = link.feature.nodeDataEnd
				this.currentNodeDataEnd = link.feature.nodeDataStart

		}
		$('#btnSearch').hide()
		$("#btnModeResume").hide();
		$("#btnModeSwitchToggle").hide();
		$("#station_overlay_top").show();
		$("#station_overlay_bottom").show()
		$("#station_overlay_top_name").text(this.currentNodeDataEnd.name);
		$("#station_overlay_top_img").attr('src', this.currentNodeDataEnd.popupPreviewURL);
		$("#station_overlay_bottom_name").text(this.currentNodeDataStart.name);
		$("#station_overlay_bottom_img").attr('src', this.currentNodeDataStart.popupPreviewURL);
		this.projectedUserLocationDisplay.setDisplayUserLocation(true);
		this.projectedUserLocationDisplay.updateUserLocationDisplay(link.closestPoint);
		if (mapViewerOptions.showCoords) {
			this.projectedUserLocationDisplay.popupCoords.panMapIfOutOfView = false;
			this.projectedUserLocationDisplay.popupCoords.show(link.closestPoint, link.closestPoint[0] + "</br>" + link.closestPoint[1] + "</br>" + ol.proj.toLonLat(link.closestPoint)[0] + "</br>" + ol.proj.toLonLat(link.closestPoint)[1]);
		}
		this.navigatorCore.userLocationDisplay.setDisplayUserLocation(false);

		//lock map
		
		if (!wasLocked) {
			//map.getView().setZoom(mapViewerOptions.navZoom);
			map.getView().animate({
				zoom: mapViewerOptions.navZoom,
				//	anchor: link.closestPoint,
				duration: 500,
			});
		}

		//map.getView().setCenter(link.closestPoint);
		map.getView().animate({
			center: link.closestPoint,
			duration: 200,
		});
		var angleX
		if (this.dir_outbound()) {
			angleX = this.currentNodeDataStart['angleX'];
		} else if (this.dir_inbound()) {
			angleX = this.currentNodeDataEnd['angleX'];
		}
		if (angleX) {

			var angleRad;
			function callback(complete) {
				if (!complete) {
					console.log("completing" + angleRad)
					map.getView().rotate(angleRad, link.closestPoint);
				}
		    }
			if (this.dir_outbound())
				angleRad = angleX['angleRad'] - Math.PI / 2;
			else if (this.dir_inbound())
				angleRad = angleX['angleRad'] - Math.PI * 3 / 2;
			if (!wasLocked || angleRad!= currentRad) {
				//console.log("turning");
				map.getView().animate({
					rotation: angleRad,
					anchor: link.closestPoint,
					duration: 500,
				},callback);
			}
		}
		wasLocked = true;

	}
		
	var wasLocked = false	
	var currentRad;
	
	this.unlockMap = function () {
		if (mapViewerOptions.showCoords) {
			this.projectedUserLocationDisplay.popupCoords.panMapIfOutOfView = false;
			this.projectedUserLocationDisplay.popupCoords.show(this.navigatorCore.locationManager.getLastKnownLocation(), this.navigatorCore.locationManager.getLastKnownLocation()[0] + "</br>" + this.navigatorCore.locationManager.getLastKnownLocation()[1] + "</br>" + ol.proj.toLonLat(this.navigatorCore.locationManager.getLastKnownLocation())[0] + "</br>" + ol.proj.toLonLat(this.navigatorCore.locationManager.getLastKnownLocation())[1]);
		}
		$('#btnSearch').show()
		$("#station_overlay_top").hide();
		$("#station_overlay_bottom").hide();
		this.projectedUserLocationDisplay.setDisplayUserLocation(false);
		this.navigatorCore.userLocationDisplay.setDisplayUserLocation(true);
		if(this.navigatorCore.locationManager.getLastKnownLocation())
			this.navigatorCore.userLocationDisplay.updateUserLocationDisplay(this.navigatorCore.locationManager.getLastKnownLocation())
		$("#btnModeSwitchToggle").show();
		if (wasLocked)
			setMode(mode_lockAndRotateMap);	
		wasLocked =false;
	
	}
		
	this.lockMapStation = function (node) {
		// mainLayer.getSource().refresh();
		if (mapViewerOptions.showCoords) {
			this.projectedUserLocationDisplay.popupCoords.panMapIfOutOfView=false;
			this.projectedUserLocationDisplay.popupCoords.show(this.navigatorCore.locationManager.getLastKnownLocation(), this.navigatorCore.locationManager.getLastKnownLocation()[0]+"</br>"+this.navigatorCore.locationManager.getLastKnownLocation()[1]+"</br>"+ol.proj.toLonLat(this.navigatorCore.locationManager.getLastKnownLocation())[0]+"</br>"+ol.proj.toLonLat(this.navigatorCore.locationManager.getLastKnownLocation())[1]);
			}
		$('#btnSearch').show()
		$("#station_overlay_top").hide();
		$("#station_overlay_top_name").text(node.feature.nodeData.name);
		
		$("#station_overlay_bottom").hide()
        this.projectedUserLocationDisplay.setDisplayUserLocation(false);
		this.navigatorCore.userLocationDisplay.setDisplayUserLocation(true);
		this.navigatorCore.userLocationDisplay.updateUserLocationDisplay(this.navigatorCore.locationManager.getLastKnownLocation())
		
		$("#btnModeSwitchToggle").show();
		if (wasLocked){
			console.log("locking map on station")
			setMode(mode_lockAndRotateMap);	
			//map.getView().setZoom(mapViewerOptions.stationZoom);
			  	map.getView().animate({
				zoom: mapViewerOptions.stationZoom,
			//	anchor: link.closestPoint,
				duration: 500,
			});
		}
		wasLocked =false

	
	}
	
	this.updatePathDirectionsNotOnPath = function (startPoint, pathPoint) {
		var walkingDirection = this.createWalkingDirectionWalkToPath(startPoint, pathPoint);
		this.pathDirections.push(walkingDirection);
		//add next node pathDirections
		//this.updatePathDirectionsNode(nextNode);

	}
	
	this.isTrueTurn = function (nodeData) {
		var target_id = nodeData['target_id'];
		var point = navigatorCore.navBackboneFLayer.points[target_id];
		//return point['links'] && Object.keys(point['links']).length > 2 
		var angleX = nodeData['angleX'];
		//console.log("angleX: " + angleX)
		//console.log("navigatorCore.turnInstructionCrossingMinAngle: " + navigatorCore.turnInstructionCrossingMinAngle)
		if (angleX) 	
		return(Object.keys(point['links']).length > 2 && (Math.abs(angleX['angleTurnDeg']) > navigatorCore.turnInstructionCrossingMinAngle))||((Object.keys(point['links']).length <=2 && (Math.abs(angleX['angleTurnDeg']) > navigatorCore.turnInstructionBendMinAngle)))
		else return false;
	}
	
	this.nextTrueTurn = function (nodeData) {
		
		var currentNode = nodeData;
		if (!this.isTrueTurn(currentNode)){
			while ( currentNode["nextNode"]!=undefined ) {
				if (this.isTrueTurn(currentNode["nextNode"])) return currentNode["nextNode"];
				currentNode = currentNode["nextNode"]
			}
		} else {
			return currentNode
		}

	}

	this.updatePathDirectionsLink = function (startPoint, nextNode) {
		//var walkingDirection = this.createWalkingDirection(startPoint, nextNode['coord']);
		var walkingDirection = this.createWalkingDirectionTillNextTrueTurn(startPoint, nextNode);
		this.pathDirections.push(walkingDirection);
		//add next node pathDirections
		this.updatePathDirectionsNode(nextNode);

	}

	this.updatePathDirectionsNode = function (nodeData) {

		//nodeData['coord']
		//nodeData['nav_name']
		//nodeData['type']
		//nodeData['target_id']
	//	var isTrueTurn =  this.isTrueTurn(nodeData) 
		//console.log("isTrueTurn: " + isTrueTurn)
		if( this.pathDirections.length>1) return;
		if(this.isTrueTurn(nodeData) && this.pathDirections.length>0){
			var angleX = nodeData['angleX'];
			if (angleX) {
				var angleTurnDeg = angleX['angleTurnDeg'];
				if (angleTurnDeg) {
					var turnDirection = this.createTurnDirection(angleTurnDeg);
					this.pathDirections.push(turnDirection);
				}
			}
		}
		var nextNode = nodeData['nextNode'];
		if (nextNode ) {
			//var walkingDirection = this.createWalkingDirection(nodeData['coord'], nextNode['coord']);
			if (this.aproachingNode){
				var walkingDirection = this.createWalkingDirectionTillNextTrueTurn(nodeData['coord'], nextNode);
				this.pathDirections.push(walkingDirection);
				
			}
			var nextTrueTurn = this.nextTrueTurn(nextNode)
			if (nextTrueTurn){
			//	console.log("nextTrueTurn: " +nextTrueTurn['target_id'])
				this.updatePathDirectionsNode(nextTrueTurn);
			}

		} else {
			var arriveDirection = this.createArriveDirection();
			this.pathDirections.push(arriveDirection);
		}
		var prevNode = nodeData['prevNode'];
		if (!prevNode && nextNode) {
			//add next node pathDirections
			this.updatePathDirectionsNode(nextNode);
		}

	}

	this.createArriveDirection = function (start, end) {
		var direction = {
			'type' : 'arrive',
			'text' : langString (language, 'direction_arrived')
		}
		return direction;
	}

	this.createWalkingDirection = function (start, end) {
		var distance = this.getDistanceMeteres(start, end);
		var direction = {
			'type' : 'walk',
			'distance' : distance,
			'text' : langString (language, 'direction_walk')
		}
		return direction;
	}
	
	this.createWalkingDirectionTillNextTrueTurn = function (start, startNodeData) {
		var distance = this.getDistanceMeteres(start, startNodeData['coord']);
		var currentNode = startNodeData;
		if (!this.isTrueTurn(currentNode)){
			while ( currentNode["nextNode"]!=undefined ) {
				distance += this.getDistanceMeteres(currentNode['coord'], currentNode["nextNode"]['coord']);
				if (this.isTrueTurn(currentNode["nextNode"])) break;
				currentNode = currentNode["nextNode"]
			}
		}
		var direction = {
			'type' : 'walk',
			'distance' : distance,
			'text' : langString (language, 'direction_walk')
		}
		return direction;
	}
	
	this.createWalkingDirectionWalkToPath = function (start, end) {
		var distance = this.getDistanceMeteres(start, end);
		var direction = {
			'type' : 'walk_to_path',
			'distance' : distance,
			'text' : langString (language, 'direction_walk_to_path')

		}
		return direction;
	}

	this.createTurnDirection = function (angleTurnDeg) {
		var direction = {
			'type' : 'turn',
			'deeres' : angleTurnDeg
		}

		if (Math.abs(angleTurnDeg) > 160) {
			direction.turn = 'turn_around';
			direction.text = langString (language, 'direction_turn_around');
		} else {
			if (this.sign(angleTurnDeg) == 1) {
				if (Math.abs(angleTurnDeg) < 45) {
					direction.turn = 'slight_right';
					direction.text = langString (language, 'direction_slight_right');
				} else if (Math.abs(angleTurnDeg) >= 45 && Math.abs(angleTurnDeg) <= 135) {
					direction.turn = 'right';
					direction.text = langString (language, 'direction_right');
				} else {
					direction.turn = 'sharp_right';
					direction.text = langString (language, 'direction_sharp_right');
				}

			} else {
				if (Math.abs(angleTurnDeg) < 45) {
					direction.turn = 'slight_left';
					direction.text = langString (language, 'direction_slight_left');
				} else if (Math.abs(angleTurnDeg) >= 45 && Math.abs(angleTurnDeg) <= 135) {
					direction.turn = 'left';
					direction.text = langString (language, 'direction_left');
				} else {
					direction.turn = 'sharp_left';
					direction.text = langString (language, 'direction_sharp_left');
				}

			}

		}

		return direction;

	}

	this.createTurnDirectionOrientation = function (angleTurnDeg) {
		var direction = {
			'type' : 'turn',
			'deeres' : angleTurnDeg
		}

		if (Math.abs(angleTurnDeg) > 135) {
			direction.turn = 'turn_around';
			direction.text = langString (language, 'direction_turn_around');
		} else {
			if (this.sign(angleTurnDeg) == 1) {
				if (Math.abs(angleTurnDeg) < 45) {
					direction.turn = 'slight_right';
					direction.text = langString (language, 'direction_slight_right');
				} else if (Math.abs(angleTurnDeg) >= 45 && Math.abs(angleTurnDeg) <= 135) {
					direction.turn = 'right';
					direction.text = langString (language, 'direction_right');
				}

			} else {
				if (Math.abs(angleTurnDeg) < 45) {
					direction.turn = 'slight_left';
					direction.text = langString (language, 'direction_slight_left');
				} else if (Math.abs(angleTurnDeg) >= 45 && Math.abs(angleTurnDeg) <= 135) {
					direction.turn = 'left';
					direction.text = langString (language, 'direction_left');
				}

			}

		}

		return direction;

	}
	
	this.getClosestPathFeatures = function (newLocation) {
		var dest = this.pathFeatures[this.pathFeatures.length-1].getGeometry().getCoordinates();
		var result = {};
		var closestNode = {};
		var closestLink = {};
		var closestObject;

		for (var i = 0; i < this.pathFeatures.length; i++) {
			var feature = this.pathFeatures[i]
				if (feature.get('type') == 'path-link') {
					closestObject = closestLink;
				if (!closestObject.closetDistance) {
					closestObject.closestPoint = feature.getGeometry().getClosestPoint(newLocation);
					closestObject.closetDistance = this.navigatorCore.navBackboneFLayer.getDistance(newLocation, closestObject.closestPoint);
					closestObject.feature = feature;
				} else {
					var newClosestPoint = feature.getGeometry().getClosestPoint(newLocation);
					var newClosestDistance = this.navigatorCore.navBackboneFLayer.getDistance(newLocation, newClosestPoint);
					var newDistanceToDestination = this.navigatorCore.navBackboneFLayer.getDistance( newClosestPoint,dest);
					if (newClosestDistance < closestObject.closetDistance) {
						closestObject.closestPoint = newClosestPoint;
						closestObject.closetDistance = newClosestDistance;
						closestObject.feature = feature;
					}
				}
			}

		}
		
		var end2 = closestLink.feature['nodeDataEnd']['feature']
		var end3 = closestLink.feature['nodeDataStart']['feature']
		var distEnd2 = this.navigatorCore.navBackboneFLayer.getDistance(newLocation, end2.getGeometry().getClosestPoint(newLocation));
		var distEnd3 = this.navigatorCore.navBackboneFLayer.getDistance(newLocation, end3.getGeometry().getClosestPoint(newLocation));
		if(distEnd2>distEnd3) end2 = end3;
		
		closestNode = {};
		closestNode.feature = end2;
		closestNode.closestPoint = end2.getGeometry().getClosestPoint(newLocation);
		result['node'] = closestNode;
		result['link'] = closestLink;
		//	console.log("closest node= " +  result['node'].closestPoint);
		//	console.log("closest link start= " +  result['link'].feature.nodeDataStart["target_id"]);
		//	console.log("closest link end " +  result['link'].feature.nodeDataEnd["target_id"]);

		return result;
	}

	this.getDistanceMeteres = function (coord1, coord2) {
		return Math.round(Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2)) * navigatorCore.mapMetersPerCoordinatePoint);
	}

	this.getDistance = function (coord1, coord2) {
		return Math.round(Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2)));
	}

}



function ProjectedUserLocationDisplay(navigatorCore){
	
this.navigatorCore=navigatorCore;
this.displayUserLocation = false;
this.acuracy =10;
this.vectorLocation=this.navigatorCore.vectorLocation;

this.iconStyle = new ol.style.Icon(/** @type {olx.style.IconOptions} */
		({
			anchor : [0.5, 0.5],
			anchorXUnits : 'fraction',
			anchorYUnits : 'fraction',
			scale: 0.2,
			src : './img/gondola.png'

		}));




this.setDisplayUserLocation = function(display) {
	//console.log("setDisplayUserLocation: "+ display)
	this.displayUserLocation = display;
	if (!this.displayUserLocation) {
		//console.log("setDisplayUserLocation: "+ display)
		if (this.vectorLocation.getSource().getFeatureById("userLocationIconFeature_pr")) {
			this.vectorLocation.getSource().removeFeature(this.userLocationIconFeature);
			this.userLocationIconFeature =undefined
		}
	
	}
}

this.createUserLocationIcon = function() {
	var userLocationIconFeature = new ol.Feature({
			id : 'userLocationIconFeature_pr',
			type : 'icon',
			geometry : new ol.geom.Point([0, 0]),
			name : 'icon marker'
		});
	userLocationIconFeature.setId('userLocationIconFeature_pr');
	var userLocationIconStyle = new ol.style.Style({
			image : this.iconStyle
		});

	userLocationIconFeature.setStyle(userLocationIconStyle);
	return userLocationIconFeature;
}


this.updateUserLocationDisplay = function(newLocation) {
	if(!ol.extent.containsCoordinate(viewableBounds, newLocation)){
			return;
		}
	if (this.displayUserLocation) {
		this.userLocationIconFeature = this.vectorLocation.getSource().getFeatureById("userLocationIconFeature_pr");
		if (!this.userLocationIconFeature) {
			this.userLocationIconFeature = this.createUserLocationIcon();
			this.vectorLocation.getSource().addFeature(this.userLocationIconFeature);
		}
		this.userLocationIconFeature.getGeometry().setCoordinates(newLocation);
		
	}
}
this.popupCoords;


this.initCoordPopupDisplay = function() {

	this.popupCoords = new ol.Overlay.Popup();
	map.addOverlay(this.popupCoords);
   $(this.popupCoords.container).addClass("tour");

}
}